// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0
// source: decision.sql

package generated

import (
	"context"

	"github.com/google/uuid"
)

const decisionCreate = `-- name: DecisionCreate :exec
INSERT INTO digilab_demo_fbs.decisions
(id, run_id, woz_object_id, amount) 
VALUES (
    $1, $2, $3, $4
)
`

type DecisionCreateParams struct {
	ID          uuid.UUID
	RunID       uuid.UUID
	WozObjectID uuid.UUID
	Amount      int32
}

func (q *Queries) DecisionCreate(ctx context.Context, arg *DecisionCreateParams) error {
	_, err := q.exec(ctx, q.decisionCreateStmt, decisionCreate,
		arg.ID,
		arg.RunID,
		arg.WozObjectID,
		arg.Amount,
	)
	return err
}

const decisionsBasedOnWozObject = `-- name: DecisionsBasedOnWozObject :many
SELECT id, run_id, woz_object_id, amount, created_at
FROM digilab_demo_fbs.decisions
WHERE woz_object_id=$1
`

func (q *Queries) DecisionsBasedOnWozObject(ctx context.Context, wozObjectID uuid.UUID) ([]*DigilabDemoFbsDecision, error) {
	rows, err := q.query(ctx, q.decisionsBasedOnWozObjectStmt, decisionsBasedOnWozObject, wozObjectID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsDecision{}
	for rows.Next() {
		var i DigilabDemoFbsDecision
		if err := rows.Scan(
			&i.ID,
			&i.RunID,
			&i.WozObjectID,
			&i.Amount,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
